﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Castle.ActiveRecord;
using NHibernate.Expression;
using Castle.Components.Validator;

namespace DomainObjects.Entities
{
    [ActiveRecord(Table="tblDepartments")]
    public class Department : ActiveRecordBase<Department>
    {
        private int _id;
        private string _name;
        private string _abbreviation;
        private DateTime? _dateCreated;
        private DateTime? _dateModified;

        [PrimaryKey(Column="DepartmentID")]      
        public int Id
        {
            get { return _id; }
            set { _id = value; }
        }

        [Property]
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        [Property]
        public string Abbreviation
        {
            get { return _abbreviation; }
            set { _abbreviation = value; } 
        }

        [Property]
        public DateTime? DateCreated
        {
            get {

                if (_dateCreated == null)
                    _dateCreated = DateTime.Now;

                return _dateCreated;
            
            }
            set { _dateCreated = value; } 
        }

        [Property]
        public DateTime? DateModified
        {
            get
            {
                if (_dateModified == null)
                    _dateModified = DateTime.Now;
                
                return _dateModified;

            }
            set {


                _dateModified = value;
            
            } 
        }

     
    }
}
